----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:50:09 08/11/2010 
-- Design Name: 
-- Module Name:    Averaging_Main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity Averaging_Main is
    
	 Generic ( SIGNAL_WIDE 						: integer := 9999);
	 
	 Port 	( SAMPLING_DATA_FROM_ADC		: in  STD_LOGIC_VECTOR (15 downto 0);
				  SQUARE_WAVE_OUTPUT				: buffer STD_LOGIC;
				  CLK_FOR_ADC_20MHZ				: out  std_logic;
				  SYSTEM_CLK_200MHZ_P			: in	 std_logic;	
			     SYSTEM_CLK_200MHZ_N			: in	 std_logic;
				  FIFO_DATA_OUT					: out std_logic_VECTOR (7 downto 0);
				  USB_1_CTS   						: out  std_logic;
				  USB_1_RX    						: out  std_logic;
				  RESET								: in	std_logic
				  );

end Averaging_Main;




architecture Behavioral of Averaging_Main is

component CLOCK_DIVIDER
port
 (
  CLK_IN1_P         : in     std_logic;
  CLK_IN1_N         : in     std_logic;
  CLK_OUT1          : out    std_logic;
  CLK_OUT2          : out    std_logic;
  CLK_OUT3			  : out	  std_logic
 );
end component;

Component Simulate_Square_Wave
port
 (  		SQUARE_WAVE_OUT	 			: buffer STD_LOGIC;
			ADDER_BYPAS_ENABLE			: out STD_LOGIC;
			LAST_WAVE_REACHED				: out STD_LOGIC;
			FALLING_EDGE_TRIGGER			: out std_logic;
			CLK_20MHZ						: in	std_logic;
			RESET								: in	std_logic
			);
end component;

Component Averaging
port (
			START_TRIGGER 								: in  STD_LOGIC;
         SWITCH_BLOCK_RAMS							: in	std_logic;
			ADC_DATA				 						: in  STD_LOGIC_VECTOR (15 downto 0);
			ADDER_BYPASS								: in 	std_logic;
			--ADDER_DATA_FROM_RAM1_ENABLE 			: in 	std_logic;	
			DATA_FROM_ADDER_TO_SPRAM				: out std_logic_vector (24 downto 0);
			SPRAM_DATA									: in  std_logic_vector (24 downto 0);
			SPRAM_ADDRESS_AVERAGING_CYCLE   		: out std_logic_vector (12 downto 0);
			RAM_WEA_AVERAGING_CYCLE					: out std_logic_vector (0 downto 0);
			CLK_100MHZ 									: in  STD_LOGIC;
			RESET											: in  STD_LOGIC);
end component;


component Switch_SP_Rams

Port	(	SWITCH_BLOCK_RAMS					    	 : in 	std_logic;
			CLK_100MHZ							    	 : in 	std_logic;
			DATA_INPUT_SPRAM					    	 : in	std_logic_VECTOR(24 downto 0);
			SPRAM_DATA_OUTPUT_FOR_AVERAGING	  	 : out std_logic_VECTOR(24 downto 0);
			SPRAM_DATA_OUTPUT_FOR_FIFO				 : out std_logic_VECTOR(24 downto 0);
			SPRAM_WEA_ENABLE						  	 : in 	std_logic_vector(0 downto 0);
			SPRAM_ADDRESS_CYCLE_AVERAGING		 	 : in 	std_logic_VECTOR(12 downto 0);
			SPRAM_ADDRESS_CYCLE_FIFO 			  	 : in 	std_logic_VECTOR(12 downto 0);
			RAM_WEA_CYCLE							    : in	std_logic_vector (0 downto 0);
			RESET				 							 : in 	std_logic
			);
end component;


Component  Preparation_for_Fifo_16Bit_to_8_Bit

Port (	CLK_100MHZ 						: in std_logic;
			SPRAM_ADDRESS_FIFO_CYLCE	: out std_logic_vector (12 downto 0); 
			FIFO_ENABLE						: in std_logic;
			DATA_FROM_SPRAM		   	: in std_logic_VECTOR(24 downto 0);
			--FIFO_DATA_OUT					: out std_logic_VECTOR (15 downto 0);
			FIFO_WRITE_ENABLE_OUT		: out std_logic;
			FIFO_DATA_IN					: out std_logic_vector (15 downto 0);
			RESET				 				: in 	std_logic);
		
end component;


component UART_TX is

port( 
	 -- Systemtakt
	 CLK_100MHZ	: in	std_logic;
    -- Input
    data_in     : in    std_logic_vector (15 downto 0);
    data_en     : in    std_logic;
	-- Serielle Daten Ausgabe ber USBtoSerial Chip
    USB_1_CTS   : out 	std_logic;
    USB_1_RX    : out 	std_logic; 
    -- Reset
	 RESET_FIFO	 : in	   std_logic;
	 RESET		 : in	   std_logic
    );
end component;


--Signal RESET										: std_logic;	
Signal BYPASS										: std_logic;						
Signal EDGE_TRIGGER								: std_logic;
Signal SWITCH_TRIGGER							: std_logic;	
Signal ADDER_DATA									: std_logic_vector (24 downto 0);
Signal OUT_DATA_FROM_SPRAM1				   : std_logic_vector (24 downto 0);
Signal OUT_DATA_FROM_SPRAM2				   : std_logic_vector (24 downto 0);
Signal RAM_WEA										: std_logic_vector (0 downto 0);
Signal WEA_EN										: std_logic;
Signal CLOCK_20MHZ								: std_logic;
signal CLOCK_20MHZ_INV							: std_logic;
Signal CLOCK_100MHZ								: std_logic;
Signal COUNTER_SIGNAL_WIDE						: integer range 0 to SIGNAL_WIDE;
Signal COUNTER_SIGNAL_WIDE_ENABLE 			: std_logic:= '1';
Signal COUNTER_6_TAU								: integer range 0 to 7199;
Signal ADDRESS_CYCLE1							: std_logic_vector (12 downto 0);
Signal ADDRESS_CYCLE2							: std_logic_vector (12 downto 0);
Signal FIFO_DATA_UART_IN						: std_logic_vector (15 downto 0);
Signal FIFO_WRITE_ENABLE_UART					: std_logic;
signal SQUARE_WAVE_PULS_FOR_INIT_IN			: std_logic;

begin


	Component_1:	CLOCK_DIVIDER
	port map
				(CLK_IN1_P          => SYSTEM_CLK_200MHZ_P,
				 CLK_IN1_N          => SYSTEM_CLK_200MHZ_N,
				 CLK_OUT1           => CLOCK_100MHZ,
				 CLK_OUT2           => CLOCK_20MHZ,
				 CLK_OUT3			  => CLOCK_20MHZ_INV);	

	Component_2:	Simulate_Square_Wave
	port map
				(SQUARE_WAVE_OUT			=> SQUARE_WAVE_OUTPUT,
				 ADDER_BYPAS_ENABLE		=> BYPASS,
				 FALLING_EDGE_TRIGGER	=> EDGE_TRIGGER,
				 LAST_WAVE_REACHED		=>	SWITCH_TRIGGER,
				 CLK_20MHZ					=> CLOCK_20MHZ,
				 RESET						=> RESET
				 );

	
	Component_3:	Averaging 
	port map (
				START_TRIGGER 						=> EDGE_TRIGGER,
				SWITCH_BLOCK_RAMS					=>	SWITCH_TRIGGER,
				ADC_DATA				 				=> SAMPLING_DATA_FROM_ADC,
				ADDER_BYPASS						=>	BYPASS,
				--ADDER_DATA_FROM_RAM1_ENABLE 	=> '1',
			   DATA_FROM_ADDER_TO_SPRAM		=> ADDER_DATA,
				SPRAM_DATA							=> OUT_DATA_FROM_SPRAM1,
				SPRAM_ADDRESS_AVERAGING_CYCLE => ADDRESS_CYCLE1,
				RAM_WEA_AVERAGING_CYCLE			=> RAM_WEA,
				CLK_100MHZ 							=> CLOCK_100MHZ,
				RESET									=> RESET);

	
	
	Component_4: Switch_SP_Rams

	port map	(	SWITCH_BLOCK_RAMS							=> SWITCH_TRIGGER,
					CLK_100MHZ									=> CLOCK_100MHZ,
					DATA_INPUT_SPRAM							=> ADDER_DATA,
					SPRAM_DATA_OUTPUT_FOR_AVERAGING		=> OUT_DATA_FROM_SPRAM1,
					SPRAM_DATA_OUTPUT_FOR_FIFO				=> OUT_DATA_FROM_SPRAM2,
					SPRAM_WEA_ENABLE							=> "0",
					SPRAM_ADDRESS_CYCLE_AVERAGING			=> ADDRESS_CYCLE1,
					SPRAM_ADDRESS_CYCLE_FIFO				=> ADDRESS_CYCLE2,
					RAM_WEA_CYCLE								=> RAM_WEA,
					RESET											=> RESET
					);
				
	
	Component_5:  Preparation_for_Fifo_16Bit_to_8_Bit 	
	port map (	
					
					
					CLK_100MHZ 							=> CLOCK_100MHZ,
					SPRAM_ADDRESS_FIFO_CYLCE		=> ADDRESS_CYCLE2,
					DATA_FROM_SPRAM		  			=> OUT_DATA_FROM_SPRAM2,
					FIFO_ENABLE							=> SWITCH_TRIGGER,
					--FIFO_DATA_OUT						=> FIFO_DATA_UART_IN,
					FIFO_WRITE_ENABLE_OUT			=> FIFO_WRITE_ENABLE_UART,
					FIFO_DATA_IN						=> FIFO_DATA_UART_IN,
					RESET									=> RESET
					);	
								
				
	Component_6: UART_TX 

	port map ( 
					 -- Systemtakt
					 CLK_100MHZ							=>	CLOCK_100MHZ,
					 -- Input
					 data_in    						=> FIFO_DATA_UART_IN,
					 data_en     						=> FIFO_WRITE_ENABLE_UART,
					 -- Serielle Daten Ausgabe ber USBtoSerial Chip				
					 USB_1_CTS							=> USB_1_CTS,
					 USB_1_RX 							=> USB_1_RX,
					 RESET_FIFO							=> '0',
					 RESET								=> RESET					 
				);

--CLK_FOR_ADC_20MHZ <=	CLOCK_20MHZ or CLOCK_20MHZ; -- Dient zur Simulation da ODDR_inst nicht simulierbar ist
	
	-- Clock Netz fr CLK_FOR_ADC_20MHZ fr die Kommunikation nach drauen
	-- ODDR2: Output Double Data Rate Output Register with Set, Reset
   --        and Clock Enable. 
   --        Spartan-6
   -- Xilinx HDL Language Template, version 12.1
	
   ODDR2_inst : ODDR2
   generic map(
      DDR_ALIGNMENT => "C0", -- Sets output alignment to "NONE", "C0", "C1" 
      INIT => '0', -- Sets initial state of the Q output to '0' or '1'
      SRTYPE => "ASYNC") -- Specifies "SYNC" or "ASYNC" set/reset
   port map (
      Q  => CLK_FOR_ADC_20MHZ, -- 1-bit output data
      C0 => CLOCK_20MHZ, -- 1-bit clock input
      C1 => CLOCK_20MHZ_INV, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => '1',--CLOCK_20MHZ,   -- 1-bit data input (associated with C0)
      D1 => '0',--CLOCK_20MHZ,   -- 1-bit data input (associated with C1)
      R  => '0',--CLOCK_20MHZ_INV,    -- 1-bit reset input
      S  => '0'--CLOCK_20MHZ     -- 1-bit set input
   );
  
   -- End of ODDR2_inst instantiation  



end Behavioral;




