--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   09:01:00 08/19/2010
-- Design Name:   
-- Module Name:   C:/Xilinx/Project_Averaging/Averaging/Averaging_Main_Bench1.vhd
-- Project Name:  Averaging
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: Averaging_Main
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY Averaging_Main_Bench1 IS
END Averaging_Main_Bench1;
 
ARCHITECTURE behavior OF Averaging_Main_Bench1 IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Averaging_Main
    PORT(
         SAMPLING_DATA_FROM_ADC : IN  std_logic_vector(15 downto 0);
         SQUARE_WAVE_OUTPUT : buffer  std_logic;
         CLK_FOR_ADC_20MHZ : OUT  std_logic;
         SYSTEM_CLK_200MHZ_P : IN  std_logic;
         SYSTEM_CLK_200MHZ_N : IN  std_logic;
			RESET						: IN std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal SAMPLING_DATA_FROM_ADC : std_logic_vector(15 downto 0) := (others => '0');
   signal SYSTEM_CLK_200MHZ_P : std_logic := '0';
   signal SYSTEM_CLK_200MHZ_N : std_logic := '0';
	signal RESET					: std_logic := '0';
	
 	--Outputs
   signal SQUARE_WAVE_OUTPUT : std_logic;
   signal CLK_FOR_ADC_20MHZ : std_logic;
	
   -- Clock period definitions
    constant SYSTEM_CLK_200MHZ_P_period : time := 5 ns;
	 constant SYSTEM_CLK_200MHZ_N_period : time := 5 ns;

 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Averaging_Main PORT MAP (
          SAMPLING_DATA_FROM_ADC => SAMPLING_DATA_FROM_ADC,
          SQUARE_WAVE_OUTPUT => SQUARE_WAVE_OUTPUT,
          CLK_FOR_ADC_20MHZ => CLK_FOR_ADC_20MHZ,
          SYSTEM_CLK_200MHZ_P => SYSTEM_CLK_200MHZ_P,
          SYSTEM_CLK_200MHZ_N => SYSTEM_CLK_200MHZ_N,
			 RESET					=>  RESET
        );

  
	   -- Clock process definitions
   SYSTEM_CLK_200MHZ_P_process :process
   begin
		SYSTEM_CLK_200MHZ_P <= '1';
		wait for SYSTEM_CLK_200MHZ_P_period/2;
		SYSTEM_CLK_200MHZ_P <= '0';
		wait for SYSTEM_CLK_200MHZ_P_period/2;
   end process;
 
	SYSTEM_CLK_200MHZ_N_process :process
   begin
	
		SYSTEM_CLK_200MHZ_N <= '0';
		wait for SYSTEM_CLK_200MHZ_N_period/2;
		SYSTEM_CLK_200MHZ_N <= '1';
		wait for SYSTEM_CLK_200MHZ_N_period/2;
   end process;

 RESET_Proc: process
 begin
 
 RESET <= '1', '0' after 1 ns;
 wait;
 end process RESET_Proc;

ADC_Data_proc: process (CLK_FOR_ADC_20MHZ, SQUARE_WAVE_OUTPUT) 
variable cnt : std_logic_vector(9 downto 0):= (others => '0');

begin      
		if RESET = '1' then 
		SAMPLING_DATA_FROM_ADC <= "0000000000000000"; 
		else
		if (falling_edge(CLK_FOR_ADC_20MHZ)) then 
			cnt := cnt + '1';
			if SQUARE_WAVE_OUTPUT= '1' and RESET = '0' then
			SAMPLING_DATA_FROM_ADC <= "0000000000000000"; 
		   elsif  cnt = "0000000111" then
			SAMPLING_DATA_FROM_ADC 	<= "011111"& cnt;  
		else
      SAMPLING_DATA_FROM_ADC 	<= "000101"& cnt;    
		end if;  
end if;
end if;		
end process ADC_Data_proc; 

 

   -- Stimulus process
   stim_proc: process
	begin
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for SYSTEM_CLK_200MHZ_N_period*10;
		wait for SYSTEM_CLK_200MHZ_P_period*10;
      -- insert stimulus here 

      wait;
   end process;

END;
