			----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:06:14 08/11/2010 
-- Design Name: 
-- Module Name:    Simulate_Square_Wave - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Simulate_Square_Wave is

	 Generic ( SIGNAL_WIDE 						: integer := 100);--999); -- BESTIMMUNG DER BREITE DER RECHTECKKURVE
	 
	 Port 	( SQUARE_WAVE_OUT			 		: buffer STD_LOGIC;
				  ADDER_BYPAS_ENABLE				: out STD_LOGIC; 
				  FALLING_EDGE_TRIGGER			: out std_logic; 
				  LAST_WAVE_REACHED 				: out std_logic;
				  CLK_20MHZ							: in	std_logic;
				  RESET								: in	std_logic);	
			     

end Simulate_Square_Wave;

architecture Behavioral of Simulate_Square_Wave is



Signal COUNTER_SIGNAL_WIDE						: integer range 0 to SIGNAL_WIDE;
Signal COUNTER_SIGNAL_WIDE_ENABLE 			: std_logic;--:='0';
Signal JUMP_TO_FIRST_STATE_ENABLE			: std_logic;--:='0';
Signal COUNTER_6_TAU								: integer range 0 to 7199;
Signal COUNTER_6_TAU_ENABLE					: std_logic; 
Signal NEXT_STATE_ENABLE						: std_logic;--:='0';
Signal FALLING_EDGE_DETECTED					: std_logic;--:='0';
Signal RISING_EDGE_DETECTED					: std_logic;--:='0';
Signal COUNTER_FALLING_EDGES 					: integer range 0 to 9;--511:=511;
Signal COUNTER_RISING_EDGES 					: integer range 0 to 9;--511:=0;


Signal LAST_RISING_WAVE							: std_logic;--:='0';
Signal SQUARE_WAVE								: std_logic;

type FSM_SIMULATE_SQUARE_WAVE 				is (SLEEPING, SIMULATION, WAITING);
Signal CURRENT_STATE								: FSM_SIMULATE_SQUARE_WAVE:= SLEEPING;
Signal NEXT_STATE									: FSM_SIMULATE_SQUARE_WAVE;

begin


---------------------------------------------------------------------------------------------
--  DIESE STATEMACHINE IST FR DEN DIE ERSTELLUNG DER RECHTECKKURVE
--
---------------------------------------------------------------------------------------------

	 SQUARE_WAVE_OUT <= SQUARE_WAVE; 
	 FALLING_EDGE_TRIGGER	<= FALLING_EDGE_DETECTED;
	 LAST_WAVE_REACHED		<= LAST_RISING_WAVE;

	SWITCH_STATE: Process (CLK_20MHZ)
	Begin
	
		if falling_edge (CLK_20MHZ) then
			CURRENT_STATE <= NEXT_STATE;
		end if;
		
	End Process SWITCH_STATE;
	
	
	FSM_SIMULATE_SQUARE_WAVE_STATEMENTS: Process (RESET, CURRENT_STATE,NEXT_STATE_ENABLE,JUMP_TO_FIRST_STATE_ENABLE)
	Begin
						 if RESET = '1' then	 
						 COUNTER_SIGNAL_WIDE_ENABLE <= '0';
						else
	
							FALLING_EDGE_DETECTED	<= '0';
							RISING_EDGE_DETECTED		<= '0';
	case CURRENT_STATE is
	
	when SLEEPING 			=>		SQUARE_WAVE				 		<= '0';
										COUNTER_SIGNAL_WIDE_ENABLE <= '0';
										COUNTER_6_TAU_ENABLE			<= '0';
										NEXT_STATE 						<= SIMULATION;

	
	when SIMULATION		=>		COUNTER_SIGNAL_WIDE_ENABLE <= '1';
										SQUARE_WAVE 					<= '1';
										COUNTER_6_TAU_ENABLE			<= '0';
										if NEXT_STATE_ENABLE = '1' then
											NEXT_STATE <= WAITING;
											FALLING_EDGE_DETECTED	<= '1';
										else
											NEXT_STATE <= SIMULATION;
											FALLING_EDGE_DETECTED	<= '0';
										end if;
										
	when WAITING			=>		SQUARE_WAVE 					<= '0';
										COUNTER_SIGNAL_WIDE_ENABLE <= '0';
										COUNTER_6_TAU_ENABLE			<= '1';
										if JUMP_TO_FIRST_STATE_ENABLE = '1' then
											NEXT_STATE <= SLEEPING;
											RISING_EDGE_DETECTED	<= '1';
										else
											NEXT_STATE <= WAITING;
											RISING_EDGE_DETECTED	<= '0';
										end if;	
	
	end case;
	
				 
	end if;			
	end Process FSM_SIMULATE_SQUARE_WAVE_STATEMENTS;
	
	
	
	-- DIESER PROZESS ZHLT DIE ZEIT FR DIE RECHTECKBREITE; DABEI BESTIMMT 'SIGNAL_WIDE' DIE BREITE DES ERZEUGTEN RECHTECKES  	
	SIMULATE_AND_DEFINE_SQUARE_WIDE : Process (CLK_20MHZ,RESET)
	Begin
	if RESET ='1' then
			NEXT_STATE_ENABLE <= '0';
	else
		if rising_edge (CLK_20MHZ) then
			if COUNTER_SIGNAL_WIDE_ENABLE = '1' then
				if COUNTER_SIGNAL_WIDE 	< SIGNAL_WIDE then
					COUNTER_SIGNAL_WIDE 	<= COUNTER_SIGNAL_WIDE + 1;
					NEXT_STATE_ENABLE 	<= '0';
				else
					COUNTER_SIGNAL_WIDE  <= 0;
					NEXT_STATE_ENABLE 	<= '1';
				end if;
			else
					COUNTER_SIGNAL_WIDE 	<= COUNTER_SIGNAL_WIDE;
					NEXT_STATE_ENABLE 	<= '0';
			end if;
		end if;
		end if;
	End Process SIMULATE_AND_DEFINE_SQUARE_WIDE;

	
	-- DIESER PROZESS ZHLT DIE ZEIT ZWISCHEN DER FALLENDEN FLANKE UND DER NCHSTEN STEIGENDEN FLANKE => 6TAU *60 USEK ABFALL = 360 USEK
	COUNT_6_TAU : Process (CLK_20MHZ,RESET)
	Begin
	if RESET ='1' then
			JUMP_TO_FIRST_STATE_ENABLE <='0'; 
	else
		if rising_edge (CLK_20MHZ) then
			if COUNTER_6_TAU_ENABLE = '1' then
				if COUNTER_6_TAU >= 7199 then -- ENTSPRICHT 360 us
					JUMP_TO_FIRST_STATE_ENABLE <= '1';
					COUNTER_6_TAU <=0;--0;
				else
					JUMP_TO_FIRST_STATE_ENABLE <= '0';
					COUNTER_6_TAU <= COUNTER_6_TAU + 1;
				end if;
			else
					JUMP_TO_FIRST_STATE_ENABLE <= '0';
					COUNTER_6_TAU <=0;
			end if;
		end if;
		end if;
	End Process COUNT_6_TAU;

	
	-- DIESER PROZESS ZHLT DIE FALLENDEN FLANKEN UM SO DIE LETZE (512) KURVE ZU BESTIMMEN
	COUNT_FALLING_EDGES : Process (CLK_20MHZ, RESET)
	Begin
	if RESET ='1' then
			 COUNTER_FALLING_EDGES <= 9;--:=511;
	else
		if falling_edge (CLK_20MHZ) then
			if FALLING_EDGE_DETECTED = '1' then
				if COUNTER_FALLING_EDGES >= 9 then--511 then
					COUNTER_FALLING_EDGES <= 0;
				else
					COUNTER_FALLING_EDGES <= COUNTER_FALLING_EDGES + 1;
				end if;
			else
				COUNTER_FALLING_EDGES <= COUNTER_FALLING_EDGES;
			end if;
		end if;
		end if;
	end Process COUNT_FALLING_EDGES;

	
	-- DIESER PROZESS BESTIMMT DIE ERSTE KURVE UND SOMIT MUSS DER BYPASS DES ADDERS AUF 1 GESETZT WERDEN
	TRACK_FIRST_WAVE : Process (CLK_20MHZ, RESET)
	Begin
		if RESET = '1' then
			ADDER_BYPAS_ENABLE <= '0';
			else
		if falling_edge(CLK_20MHZ) then
			if COUNTER_FALLING_EDGES = 0 and SQUARE_WAVE = '0' then
				ADDER_BYPAS_ENABLE <= '1';
			else
				ADDER_BYPAS_ENABLE <= '0';
			end if;
		end if;
		end if;
	End Process TRACK_FIRST_WAVE;

	
	
	-- DIESER PROZESS ZAHLT DIE STEIGENDEN FLANKEN, WIRD BENTIGT UM DAS UMSCHALTEN DES BLOCKRAMS SCHON VOR DER ERSTEN FALLENDEN FLANKE VORZUBEREITEN
	TRACK_LAST_WAVE	: Process (CLK_20MHZ, RESET)
	Begin 
	
		if RESET ='1' then
			 COUNTER_RISING_EDGES <= 0;
			 LAST_RISING_WAVE <= '0';
	  else
		if falling_edge (CLK_20MHZ) then
			if RISING_EDGE_DETECTED = '1' then
				if COUNTER_RISING_EDGES >= 9 then --511 then 
					COUNTER_RISING_EDGES <= 0;
					LAST_RISING_WAVE <= '1';
				else
					LAST_RISING_WAVE <= '0';
					COUNTER_RISING_EDGES <= COUNTER_RISING_EDGES + 1;
				end if;
			else
				LAST_RISING_WAVE <= '0';
				COUNTER_RISING_EDGES <= COUNTER_RISING_EDGES;
			end if;
		end if;
		end if;
	end Process TRACK_LAST_WAVE;

end Behavioral;

