
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_ARITH.ALL;
use IEEE.std_logic_UNSIGNED.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Switch_SP_Rams is

Port	(	SWITCH_BLOCK_RAMS							: in 	std_logic;
			CLK_100MHZ									: in 	std_logic;
			DATA_INPUT_SPRAM							: in 	std_logic_VECTOR(24 downto 0);	
			SPRAM_DATA_OUTPUT_FOR_AVERAGING	   : out std_logic_VECTOR(24 downto 0);
			SPRAM_DATA_OUTPUT_FOR_FIFO				: out std_logic_VECTOR(24 downto 0);
			SPRAM_WEA_ENABLE							: in 	std_logic_vector(0 downto 0);
			SPRAM_ADDRESS_CYCLE_AVERAGING	 		: in std_logic_VECTOR(12 downto 0);
			SPRAM_ADDRESS_CYCLE_FIFO 				: in 	std_logic_VECTOR(12 downto 0);
			RAM_WEA_CYCLE								: in std_logic_vector (0 downto 0);
			RESET											: in std_logic);
			

end Switch_SP_Rams;

architecture Behavioral of Switch_SP_Rams is

component Single_Port_Ram
	port (
	clka: IN std_logic;
	wea: IN std_logic_VECTOR(0 downto 0);
	addra: IN std_logic_VECTOR(12 downto 0);
	dina: IN std_logic_VECTOR(24 downto 0);
	douta: OUT std_logic_VECTOR(24 downto 0));
end component;


component Single_Port_Ram2
	port (
	clka: IN std_logic;
	wea: IN std_logic_VECTOR(0 downto 0);
	addra: IN std_logic_VECTOR(12 downto 0);
	dina: IN std_logic_VECTOR(24 downto 0);
	douta: OUT std_logic_VECTOR(24 downto 0));
end component;

--Signal SPRAM_WRITE_TO_FIFO_ADRESS: std_logic_vector (12 downto 0);--:="0000000000000";
Signal RAM_WEA1						: std_logic_vector (0 downto 0);	
Signal RAM_WEA2						: std_logic_vector (0 downto 0);	
Signal SPRAM_ADRESS1					: std_logic_vector (12 downto 0);--:="0000000000000";
Signal SPRAM_ADRESS2					: std_logic_vector (12 downto 0);--:="0000000000000";

--Signal SPRAM_DATA_INPUT				: std_logic_vector (24 downto 0);--:=(others => '0');


Signal SPRAM_DATA_IN1				: std_logic_vector (24 downto 0);--:="0000000000000000000000000";
Signal SPRAM_DATA_OUT1				: std_logic_vector (24 downto 0);

Signal SPRAM_DATA_IN2				: std_logic_vector (24 downto 0);--:="0000000000000000000000000";
Signal SPRAM_DATA_OUT2				: std_logic_vector (24 downto 0);

Signal ENABLE_BLOCK_RAM1			: std_logic;

type FSM_SWITCH_BLOCK_RAMS			is (ACTIVATE_BLOCK_RAM1, WAIT_STATE1, WAIT_STATE2,ACTIVATE_BLOCK_RAM2);
Signal CURRENT_STATE2				: FSM_SWITCH_BLOCK_RAMS:= ACTIVATE_BLOCK_RAM1;
Signal NEXT_STATE2					: FSM_SWITCH_BLOCK_RAMS;


begin


---------------------------------------------------------------------------------------------
--  DIESE STATEMACHINE IST FR DAS UMSCHALTEN ZWISCHEN DER BLOCKRAMS ZUSTNDIG, SIE WIRD VON DER 
-- LETZEN KURVE GETRIGGERT 
---------------------------------------------------------------------------------------------
	
		

	SWITCH_STATE2: Process (CLK_100MHZ)
	Begin
		if falling_edge (CLK_100MHZ) then
			CURRENT_STATE2 <= NEXT_STATE2;
		end if;
	End Process SWITCH_STATE2;


	BLOCK_RAM_SWITCH: Process (RESET,CURRENT_STATE2,SWITCH_BLOCK_RAMS)
	Begin
	
		if RESET = '1' then
			ENABLE_BLOCK_RAM1 <= '0';
			else
	
	case CURRENT_STATE2 is
	
	when ACTIVATE_BLOCK_RAM1	=>			ENABLE_BLOCK_RAM1 <= '1';
													if SWITCH_BLOCK_RAMS = '1' then
														NEXT_STATE2 <= WAIT_STATE1;
													else
														NEXT_STATE2 <= ACTIVATE_BLOCK_RAM1;
													end if;
													
	when WAIT_STATE1 				=>			ENABLE_BLOCK_RAM1 <= '1';
													if SWITCH_BLOCK_RAMS = '1' then
														NEXT_STATE2 <= WAIT_STATE1; -- Enable weg, dann Block RAM zwei
													else
														NEXT_STATE2 <= ACTIVATE_BLOCK_RAM2;
													end if;
			
	when ACTIVATE_BLOCK_RAM2	=>			ENABLE_BLOCK_RAM1 <= '0';
													if SWITCH_BLOCK_RAMS = '1' then
														NEXT_STATE2 <= WAIT_STATE2;
													else
														NEXT_STATE2 <= ACTIVATE_BLOCK_RAM2;
													end if;
													
	when WAIT_STATE2				=> 		ENABLE_BLOCK_RAM1 <= '0';
													if SWITCH_BLOCK_RAMS = '1' then
														NEXT_STATE2 <= WAIT_STATE2;
													else
														NEXT_STATE2 <= ACTIVATE_BLOCK_RAM1;
													end if;
		
	end case;
	end if;
	end process BLOCK_RAM_SWITCH;



	-- DIESER PROZESS BESTIMMT WELCHE DATEN BEIM UMSCHALTEN WELCHES SPRAM BEKOMMT, DA ALTERNIEREND MUSS ES GENAU UMGEKEHRT SEIN
	SWITCH_BRAM_DATA_OUTPUT: Process (CLK_100MHZ, RESET)
	Begin
	
	if (RESET = '1') then
		--SPRAM_WRITE_TO_FIFO_ADRESS <=(others => '0');
		--SPRAM_DATA_INPUT				<=(others => '0');
      SPRAM_ADRESS1								<=(others => '0');
		SPRAM_ADRESS2								<=(others => '0');
		SPRAM_DATA_IN1   							<=(others => '0');
		SPRAM_DATA_IN2								<=(others => '0');
		RAM_WEA1										<=(others => '0');
		RAM_WEA2										<=(others => '0');		
		SPRAM_DATA_OUTPUT_FOR_AVERAGING 		<=(others => '0'); 
		SPRAM_DATA_OUTPUT_FOR_FIFO 			<=(others => '0');
		
      else
	
		if falling_edge (CLK_100MHZ) then
			if ENABLE_BLOCK_RAM1 = '1' then
				SPRAM_DATA_OUTPUT_FOR_AVERAGING <= SPRAM_DATA_OUT1; 
				SPRAM_DATA_OUTPUT_FOR_FIFO <= SPRAM_DATA_OUT2; 
				SPRAM_DATA_IN1		<= DATA_INPUT_SPRAM;
				SPRAM_ADRESS1		<= SPRAM_ADDRESS_CYCLE_AVERAGING;
				SPRAM_ADRESS2		<= SPRAM_ADDRESS_CYCLE_FIFO;
				RAM_WEA1				<= RAM_WEA_CYCLE; -- Write Enable RAM_1
				RAM_WEA2				<= "0";
			else
				SPRAM_DATA_OUTPUT_FOR_AVERAGING <= SPRAM_DATA_OUT2; 
				SPRAM_DATA_OUTPUT_FOR_FIFO <= SPRAM_DATA_OUT1; 
				SPRAM_DATA_IN2		<=	DATA_INPUT_SPRAM;			
				SPRAM_ADRESS1		<= SPRAM_ADDRESS_CYCLE_FIFO;
				SPRAM_ADRESS2		<= SPRAM_ADDRESS_CYCLE_AVERAGING;
				RAM_WEA1				<= "0";
				RAM_WEA2				<= RAM_WEA_CYCLE;
			end if;
		end if;
	end if;
	end Process;



Component_1 : Single_Port_Ram
			port map (
			clka => CLK_100MHZ,
			wea => RAM_WEA1,
			addra => SPRAM_ADRESS1,
			dina => SPRAM_DATA_IN1,
			douta => SPRAM_DATA_OUT1);

Component_2 : Single_Port_Ram2
			port map (
			clka => CLK_100MHZ,
			wea => RAM_WEA2,
			addra => SPRAM_ADRESS2,
			dina => SPRAM_DATA_IN2,
			douta => SPRAM_DATA_OUT2);			



end Behavioral;

